<?php

// connexion à la base MySql
// l'identité de l'utilisateur
$ID = "admpersonnes";
$PWD = "nobody";
// identité de la base
$DSN = "mysql:host=localhost;dbname=dbpersonnes";

// connexion
list($erreur, $connexion) = connecte($DSN, $ID, $PWD);
if ($erreur) {
  print "Erreur lors de la connexion à la base [$DSN] sous l'identité ($ID,$PWD) : $erreur\n";
  exit;
}

// suppression de la table personnes si elle existe
$requête = "drop table personnes";
$erreur = exécuteRequête($connexion, $requête);
//y-a-t-il eu une erreur ?
if ($erreur)
  print "$requête : Erreur ($erreur)\n";
else
  print "$requête: Exécution réussie\n";
// création de la table personnes
$requête = "create table personnes (prenom varchar(30) NOT NULL, nom varchar(30) NOT NULL, age integer NOT NULL, primary key(nom,prenom))";
$erreur = exécuteRequête($connexion, $requête);
//y-a-t-il eu une erreur ?
if ($erreur)
  print "$requête : Erreur ($erreur)\n";
else
  print "$requête: Exécution réussie\n";
// on se déconnecte et on quitte
déconnecte($connexion);
exit;

// ---------------------------------------------------------------------------------
function connecte($dsn, $login, $pwd) {
  // connecte ($login,$pwd) à la base $dsn
  // rend l'id de la connexion ainsi qu'un code d'erreur
  try {
    // connexion
    $dbh = @new PDO($dsn, $login, $pwd, array(PDO::ATTR_PERSISTENT => true));
    // retour sans erreur
    return array("", $dbh);
  } catch (PDOException $e) {
    // retour avec erreur
    return array($e->getMessage(), null);
  }
}

// ---------------------------------------------------------------------------------
function déconnecte($connexion) {
  // ferme la connexion identifiée par $connexion
  $connexion = null;
}

// ---------------------------------------------------------------------------------
function exécuteRequête($connexion, $sql) {
  // exécute la requête $sql sur la connexion $connexion
  try {
    $connexion->exec($sql);
    // retour sans erreur
    return "";
  } catch (PDOException $e) {
    // retour avec erreur
    return $e->getMessage();
  }
}
