<?php

// couche Dao
// dépendances
require_once "impots_05_entites.php";
// constantes
define("TABLE", "impots");

// interface Dao
interface IImpotsDao {

// rend un tableau d'entités Tranche
  function getData();
}

// implémentation abstraite
abstract class ImpotsDaoWithPdo implements IImpotsDao {

// champs privés
  private $dsn;
  private $user;
  private $passwd;
  private $tranches;

// getters et setters
  public function getDsn() {
    return $this->dsn;
  }

  public function setDsn($dsn) {
    $this->dsn = $dsn;
  }

  public function getUser() {
    return $this->user;
  }

  public function setUser($user) {
    $this->user = $user;
  }

  public function getPasswd() {
    return $this->passwd;
  }

  public function setPasswd($passwd) {
    $this->passwd = $passwd;
  }

// constructeur
  public function __construct($dsn, $user, $passwd) {
// on enregistre les paramètres
    $this->setDsn($dsn);
    $this->setUser($user);
    $this->setPasswd($passwd);
// on récupère les données du Sgbd
// connecte ($user,$pwd) à la base $dsn
    try {
// connexion
      $connexion = new PDO($dsn, $user, $passwd, array(PDO::ATTR_PERSISTENT => true));
// lecture de la table $TABLE
      $requête = "select limites,coeffR,coeffN from " . TABLE;
// exécute la requête $requête sur la connexion $connexion
      $statement = $connexion->prepare($requête);
      $statement->execute();
// exploitation du résultat de la requête
      while ($colonnes = $statement->fetch()) {
        $this->tranches[] = new Tranche($colonnes[0], $colonnes[1], $colonnes[2]);
      }
// déconnexion
      $connexion=NULL;
    } catch (PDOException $e) {
// retour avec erreur
      throw new ImpotsException($e->getMessage(), 1);
    }
  }

  public function getData(){
    return $this->tranches;
  }
}

// ------------------------------------------------------------------

class ImpotsDaoWithMySQL extends ImpotsDaoWithPdo {

  public function __construct($host, $port, $base, $user, $passwd) {
    parent::__construct("mysql:host=$host;dbname=$base;port=$port", $user, $passwd);
  }

}
